/** @file csurface.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2013.10.30 -

	@brief [ csurface ]
*/

#ifndef _CSURFACE_H_
#define _CSURFACE_H_

#include <windows.h>
#include "common.h"

/**
	@brief manage DIB section
*/
class CSurface
{
protected:
	HDC       hMainDC;
	HANDLE    hMainBuf;
	HBITMAP   hMainBmp;
	scrntype *pMainBuf;

	bool      enable;

	bool Create(HDC hdc, long width, long height, HANDLE *hBuf, HBITMAP *hBmp, scrntype **pBuf, HDC *hdcDib);
	void Release(HANDLE *hBuf, HBITMAP *hBmp, HDC *hdcDib);

public:
	CSurface();
	CSurface(HDC hdc, long width, long height);
	~CSurface();

	bool Create(HDC hdc, long width, long height);
	void Release();

	HDC GetDC() { return hMainDC; }
	HANDLE GetHHeader() { return hMainBuf; }
	HBITMAP GetBitmap() { return hMainBmp; }
	scrntype *GetBuffer();
	DWORD GetBufferSize();
	LPBITMAPINFOHEADER GetHeader();
	DWORD GetHeaderSize();

	bool IsEnable() { return enable; }

	int Width();
	int Height();
};

#endif
