/** @file win_sndfilterbox.cpp

	Skelton for retropc emulator

	@author Sasaji
	@date   2015.11.26 -

	@brief [ sound filter box ]
*/

#ifdef USE_DEBUG_SOUND_FILTER

#include "win_sndfilterbox.h"
#include "../../emu.h"
#include <commctrl.h>

extern int RRX11;
extern int RRX12;
extern int RRY11;

namespace GUI_WIN
{

SndFilterBox::SndFilterBox(HINSTANCE hInst, CFont *new_font, EMU *new_emu, GUI *new_gui)
	: CDialogBox(hInst, IDD_SNDFILTERBOX, new_font, new_emu, new_gui)
{
}

SndFilterBox::~SndFilterBox()
{
}

INT_PTR SndFilterBox::onInitDialog(UINT message, WPARAM wParam, LPARAM lParam)
{
	CDialogBox::onInitDialog(message, wParam, lParam);

	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL1, TBM_SETRANGE, TRUE, MAKELPARAM(0, 1000));
	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL1, TBM_SETTICFREQ, 25, 0);
	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL1, TBM_SETPOS  , TRUE, RRX11);

	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL2, TBM_SETRANGE, TRUE, MAKELPARAM(0, 1000));
	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL2, TBM_SETTICFREQ, 25, 0);
	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL2, TBM_SETPOS  , TRUE, RRX12);

	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL3, TBM_SETRANGE, TRUE, MAKELPARAM(0, 1000));
	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL3, TBM_SETTICFREQ, 25, 0);
	SendDlgItemMessage(hDlg, IDC_SLIDER_VOL3, TBM_SETPOS  , TRUE, RRY11);

	// layout
	RECT re;

	re.top = margin;

	for(int i=0; i<=2; i++) {
		re.left = margin;
		AdjustControl(IDC_STATIC_1 + i, &re, 60, 32);
		re.left = re.right + margin;
		AdjustControl(IDC_SLIDER_VOL1 + i, &re, 500, 32);
		re.top = re.bottom + margin;
	}

	// button
	re.top = GetBottom() + margin;
	re.right = GetRight();
	AdjustButton(IDOK, 8, &re, true);

	AdjustWindow(margin);

	return (INT_PTR)TRUE;
}

INT_PTR SndFilterBox::onHScroll(UINT message, WPARAM wParam, LPARAM lParam)
{
	SetVolume();
	return (INT_PTR)TRUE;
}

INT_PTR SndFilterBox::onVScroll(UINT message, WPARAM wParam, LPARAM lParam)
{
	SetVolume();
	return (INT_PTR)TRUE;
}

INT_PTR SndFilterBox::onCommand(UINT message, WPARAM wParam, LPARAM lParam)
{
	SetVolume();

	return CDialogBox::onCommand(message, wParam, lParam);
}

void SndFilterBox::SetVolume()
{
	RRX11 = (int)SendDlgItemMessage(hDlg, IDC_SLIDER_VOL1, TBM_GETPOS, 0, 0);
	RRX12 = (int)SendDlgItemMessage(hDlg, IDC_SLIDER_VOL2, TBM_GETPOS, 0, 0);
	RRY11 = (int)SendDlgItemMessage(hDlg, IDC_SLIDER_VOL3, TBM_GETPOS, 0, 0);
	return;
}

}; /* namespace GUI_WIN */

#endif
